#######################################################
############# UltraWU Warmup Version 2.0 ##############
#######################################################

# Requirements:
# EventScripts 2.1 (Orange Box) or later
# SPE (Source Python Extensions)

#######################################################
#######################################################
#######################################################

import es, playerlib, popuplib, weaponlib, cfglib, repeat, gamethread, spe
import os.path, random

info = es.AddonInfo()
info.name = 'UltraWU Warmup'
info.version = '2.0'
info.url = 'http://addons.eventscripts.com/addons/view/ultrawu'
info.author = 'Lumpi@Work'
info.description = 'The ultimate warmup timer for CS:S'

es.set("ultrawu_ver", 2.0)
es.makepublic("ultrawu_ver")

es.msg("#multi", "#green[UltraWU]#default: #lightgreenLoaded - Made by Lump1")

wuconfig = cfglib.AddonCFG(es.getAddonPath("ultrawu") + "/ultrawu.cfg")
wu_active = wuconfig.cvar("wu_active", 0)
wu_warmup_timer = wuconfig.cvar("wu_warmup_timer", 0)
wu_countdown = wuconfig.cvar("wu_countdown", 0)
wu_countdown_position = wuconfig.cvar("wu_countdown_position", 0)
wu_enable_popup = wuconfig.cvar("wu_enable_popup", 0)
wu_disable_ff = wuconfig.cvar("wu_disable_ff", 0)
wu_respawn = wuconfig.cvar("wu_respawn", 0)
wu_only_knife = wuconfig.cvar("wu_only_knife", 0)
wu_grenades = wuconfig.cvar("wu_grenades", 0)
wu_weapon = wuconfig.cvar("wu_weapon", 0)
wu_random_weapons = wuconfig.cvar("wu_random_weapons", 0)
wu_random_exclude_snipers = wuconfig.cvar("wu_random_exclude_snipers", 0)
wu_speed = wuconfig.cvar("wu_speed", 0)
wu_mologrenades = wuconfig.cvar("wu_mologrenades", 0)
wu_molo_time = wuconfig.cvar("wu_molo_time", 0)
wu_noblock = wuconfig.cvar("wu_noblock", 0)
wu_preconfig = wuconfig.cvar("wu_preconfig", 0)
wu_afterconfig = wuconfig.cvar("wu_afterconfig", 0)
wu_mapconfigs = wuconfig.cvar("wu_mapconfigs", 0)
wu_disable_stats = wuconfig.cvar("wu_disable_stats", 0)
wu_remove_idle_weapons = wuconfig.cvar("wu_remove_idle_weapons", 0)
		
def load():
    wuconfig.execute()
    if wu_active:
        global wutimer
        wutimer = repeat.create("wutimer", timer)
        global wuremover
        wuremover = repeat.create("wuremover", remove_idle_weapons)
        global wu_timeleft
        wu_timeleft = wu_warmup_timer
        global wu_noisy_setting
        wu_noisy_setting = es.ServerVar("eventscripts_noisy")
        if not wu_noisy_setting:
            es.doblock("corelib/noisy_on")
        
def unload():
    if wu_active:
        es.msg("#multi", "#green[UltraWU]#default: #lightgreenUnloaded")
        wupopup.delete()
        repeat.delete("wutimer")
        repeat.delete("wuremover")
    
def create_popup():
    global wupopup
    wupopup = popuplib.create('ultrawu_popup')
    wupopup.addline("This server is running UltraWU Warmup")
    wupopup.addline("Made by [BuH]Lump1")
    wupopup.addline(" ")
    wupopup.addline("Features:") 
    if wu_disable_ff:
        wupopup.addline("- Friendly Fire disabled")
    if wu_respawn:
        wupopup.addline("- Instant respawn")   
    if wu_only_knife:
        wupopup.addline("- Only knife allowed")
    if wu_random_weapons:
        wupopup.addline("- Random weapons")
    if wu_grenades:
        wupopup.addline("- Unlimited HE grenades")
    if wu_speed:
        wupopup.addline("- Ultra speed mode")
    if wu_mologrenades:
        wupopup.addline("- Molotov grenades")
    if wu_noblock:
        wupopup.addline("- Noblock enabled")

def timer():
    if wu_active:
        if wu_countdown:
            global wu_timeleft
            if wu_countdown_position == 0:
                es.msg("#multi", "#green[UltraWU]#default: #lightgreen%s seconds left" %wu_timeleft)
            if wu_countdown_position == 1:
                es.centermsg("Warmup: %s seconds left" %wu_timeleft)
            if wu_countdown_position == 2:
                es.msg("#multi", "#green[UltraWU]#default: #lightgreen%s seconds left" %wu_timeleft)
                es.centermsg("Warmup: %s seconds left" %wu_timeleft)            
        if wu_timeleft == 0:
            wutimer.stop()
            wuremover.stop()
            if wu_countdown:
                if wu_countdown_position == 0:
                    es.msg("#multi", "#green[UltraWU]#default: #lightgreenTime over!")
                if wu_countdown_position == 1:
                    es.centermsg("Time over!")
                if wu_countdown_position == 2:
                    es.msg("#multi", "#green[UltraWU]#default: #lightgreenTime over!")
                    es.centermsg("Time over!")
            es.server.queuecmd("mp_restartgame 1")
            afterwarmup()
        wu_timeleft = wu_timeleft - 1
        
def remove_idle_weapons():
    if wu_active and wu_remove_idle_weapons:
        for idleweapon in weaponlib.getIndexList("#all"):
            if es.getindexprop(idleweapon, "CBaseEntity.m_hOwnerEntity") == -1:
                es.remove(idleweapon)
        
def beforewarmup():
    if wu_disable_ff:
        es.server.queuecmd("mp_friendlyfire 0")
    if wu_disable_stats:
        es.server.queuecmd("log off")
    if not wu_preconfig:
        es.server.queuecmd("exec %s" %wu_preconfig)
        
def afterwarmup():
    if wu_disable_ff:
        es.server.queuecmd("mp_friendlyfire 1")
    if wu_disable_stats:
        es.server.queuecmd("log on")
    global wu_noisy_setting
    if not wu_noisy_setting:
        es.doblock("corelib/noisy_off")
    if not wu_afterconfig:
        es.server.queuecmd("exec %s" %wu_afterconfig)
        
def mapconfig(mapname):
    wumapconfigpath = es.getAddonPath("ultrawu") + ("/maps/%s.cfg" %mapname)
    if os.path.isfile(wumapconfigpath):
        wumapconfig = cfglib.AddonCFG(wumapconfigpath)
        wu_active = wumapconfig.cvar("wu_active", 0)
        wu_warmup_timer = wumapconfig.cvar("wu_warmup_timer", 0)
        wu_countdown = wumapconfig.cvar("wu_countdown", 0)
        wu_countdown_position = wumapconfig.cvar("wu_countdown_position", 0)
        wu_enable_popup = wumapconfig.cvar("wu_enable_popup", 0)
        wu_disable_ff = wumapconfig.cvar("wu_disable_ff", 0)
        wu_respawn = wumapconfig.cvar("wu_respawn", 0)
        wu_only_knife = wumapconfig.cvar("wu_only_knife", 0)
        wu_grenades = wumapconfig.cvar("wu_grenades", 0)
        wu_weapon = wumapconfig.cvar("wu_weapon", 0)
        wu_random_weapons = wumapconfig.cvar("wu_random_weapons", 0)
        wu_random_exclude_snipers = wumapconfig.cvar("wu_random_exclude_snipers", 0)
        wu_speed = wumapconfig.cvar("wu_speed", 0)
        wu_mologrenades = wumapconfig.cvar("wu_mologrenades", 0)
        wu_molo_time = wumapconfig.cvar("wu_molo_time", 0)
        wu_noblock = wumapconfig.cvar("wu_noblock", 0)
        wu_preconfig = wumapconfig.cvar("wu_preconfig", 0)
        wu_afterconfig = wumapconfig.cvar("wu_afterconfig", 0)
        wu_mapconfigs = wumapconfig.cvar("wu_mapconfigs", 0)
        wu_disable_stats = wumapconfig.cvar("wu_disable_stats", 0)
        wu_remove_idle_weapons = wumapconfig.cvar("wu_remove_idle_weapons", 0)
        wumapconfig.execute()
    else:
        wuconfig.execute()
     
def player_activate(event_var):
    if wu_active and (wu_timeleft > 0) and wu_enable_popup:
        wupopup.send(event_var["userid"])
        
def es_map_start(event_var):
    if wu_active and wu_mapconfigs:
        mapconfig(event_var["mapname"])
    if wu_active:
        global wu_timeleft
        wu_timeleft = wu_warmup_timer
        wutimer.start(1, 0)
        if wu_remove_idle_weapons:
            wuremover.start(3, 0)
        if wu_enable_popup:
            create_popup()
        beforewarmup()      
        
def player_spawn(event_var):
    if wu_active and (wu_timeleft > 0):
        wuplayer = playerlib.getPlayer(event_var["userid"])
        wuteam = wuplayer.teamid
        if wuteam > 1:
            wuplayer.setCash(0)
            if wu_grenades:
                gamethread.delayed(.1, es.give, (wuplayer, "weapon_hegrenade"))
            if wu_only_knife:
                es.give(wuplayer, "player_weaponstrip")
                es.fire(wuplayer, "player_weaponstrip", "strip")
                gamethread.delayed(.1, es.give, (wuplayer, "weapon_knife"))
            if not wu_weapon and not wu_random_weapons:
                es.give(wuplayer, "player_weaponstrip")
                es.fire(wuplayer, "player_weaponstrip", "strip")
                gamethread.delayed(.1, es.give, (wuplayer, "weapon_knife"))
                gamethread.delayed(.1, es.give, (wuplayer, wu_weapon))
            if wu_speed:
                wuplayer.setSpeed(2)
            if wu_noblock:
                wuplayer.noblock(1)
            if wu_random_weapons:
                if wu_random_exclude_snipers:
                    wu_randomwep = "weapon_" + random.choice(["ak47", "aug", "deagle", "elite", "famas", "fiveseven", "galil", "glock", "m249", "m3", "m4a1", "mac10", "mp5navy", "p228", "p90", "sg550", "tmp", "ump45", "usp", "xm1014"])               
                else:
                    wu_randomwep = "weapon_" + random.choice(["ak47", "aug", "awp", "deagle", "elite", "famas", "fiveseven", "g3sg1", "galil", "glock", "m249", "m3", "m4a1", "mac10", "mp5navy", "p228", "p90", "scout", "sg550", "sg552", "tmp", "ump45", "usp", "xm1014"])
                es.give(wuplayer, "player_weaponstrip")
                es.fire(wuplayer, "player_weaponstrip", "strip")
                gamethread.delayed(.1, es.give, (wuplayer, "weapon_knife"))
                gamethread.delayed(.1, es.give, (wuplayer, wu_randomwep))
                            
def player_hurt(event_var):    
    if wu_active and (wu_timeleft > 0) and wu_mologrenades:
        if event_var["weapon"] == "hegrenade":
            if event_var["userid"] != event_var["attacker"]:
                es.fire(event_var["userid"], "!self", "IgniteLifetime", wu_molo_time)
                gamethread.delayed(4, es.fire, (event_var["userid"], "!self", "IgniteLifetime", 0))                      
            
def weapon_fire(event_var):
    if wu_active and (wu_timeleft > 0) and wu_grenades:
        if event_var["weapon"] == "hegrenade":
            gamethread.delayed(.1, es.give, (event_var["userid"], "weapon_hegrenade"))
        
def player_death(event_var):
    if wu_active and (wu_timeleft > 0):
        if wu_respawn:
            gamethread.delayed(1, spe.respawn, (event_var["userid"]))
